// u_c_person
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_25_rtti_invoke;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    invoke_methods_: TButton;
    invoke_constructor_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure invoke_methods_Click(Sender: TObject);
    procedure invoke_constructor_Click(Sender: TObject);
    procedure c_Click(Sender: TObject);
    procedure d_Click(Sender: TObject);
    procedure e_Click(Sender: TObject);
    procedure f_Click(Sender: TObject);
    procedure g_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses Rtti, u_display_simple, u_c_person_6, u_display_rtti;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.invoke_methods_Click(Sender: TObject);
      var l_rtti_context: TRttiContext;
          l_c_person: c_person;
          l_display_tvalue: tValue;
          l_c_person_rtti_type: tRttiType;
      begin
        l_rtti_context:= TRttiContext.Create;
        l_c_person_rtti_type:= l_rtti_context.GetType(c_person);
        display(f_display_type_kind(l_c_person_rtti_type.TypeKind));

        l_c_person := c_person.Create;

        l_display_tvalue:= l_c_person_rtti_type.GetMethod('f_display_person').Invoke(l_c_person, []);
        display(l_display_tvalue.AsString);

        display(l_c_person_rtti_type.GetMethod('f_display_person').Invoke(l_c_person, []).AsString);

        l_c_person_rtti_type.GetMethod('increment_age').Invoke(l_c_person, [3]);
      end; // invoke_methods_Click

    procedure TForm1.invoke_constructor_Click(Sender: TObject);
      var l_rtti_context: TRttiContext;
          l_c_rtti_type: tRttiType;
          l_c_person_rtti_instance_type: TRttiInstanceType;
          l_c_class_ref: tClass;
          l_c_person: tObject;
      begin
        l_rtti_context:= TRttiContext.Create;
        l_c_rtti_type:= l_rtti_context.FindType('u_c_person_6.c_person');
        display(f_display_type_kind(l_c_rtti_type.TypeKind));
        l_c_person_rtti_instance_type:= l_c_rtti_type as TRttiInstanceType;

        l_c_class_ref:= l_c_person_rtti_instance_type.MetaclassType;

        l_c_person:= l_c_person_rtti_instance_type.GetMethod('create_person').Invoke(
              l_c_class_ref, ['joe', 15, 500]).AsType<c_person>;
        display(l_c_person.ToString);
      end; // invoke_constructor_Click

    procedure TForm1.c_Click(Sender: TObject);
      begin

      end; // c_

    procedure TForm1.d_Click(Sender: TObject);
      begin

      end; // d_

    procedure TForm1.e_Click(Sender: TObject);
      begin

      end; // e_

    procedure TForm1.f_Click(Sender: TObject);
      begin

      end; // f_

    procedure TForm1.g_Click(Sender: TObject);
      begin

      end; // g_

end.
