// u_c_person
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_person_6;
  interface

    type c_person= // one "person"
             Class
               m_name: String;
               m_age: integer;
               m_salary: Double;

               Constructor create_person(p_name: String;
                   p_age: integer; p_salary: Double);
               function f_c_self: c_person;

               procedure increment_age(p_delta: Integer);
               function f_display_person: String;
               function ToString: String; Override;

               Destructor Destroy; Override;
             end; // c_person

  implementation
    uses SysUtils, u_display_simple;

    // -- c_person

    Constructor c_person.create_person(p_name: String;
        p_age: integer; p_salary: Double);
      begin
        Inherited create;
        m_name:= p_name;
        m_age:= p_age;
        m_salary:= p_salary;
      end; // create_person

    procedure c_person.increment_age(p_delta: Integer);
      begin
        Inc(m_age, p_delta);
      end; // increment_age

    function c_person.f_display_person: String;
      begin
        Result:= Format('%-10s %2d %7.2f', [m_name, m_age, m_salary]);
      end; // f_display_person

    function c_person.ToString: String;
      begin
        Result:= Format('%-10s %2d %7.2f', [m_name, m_age, m_salary]);
      end; // ToString

    function c_person.f_c_self: c_person;
      begin
        Result:= Self;
      end; // f_c_self

    Destructor c_person.Destroy;
      begin
        InHerited;
      end; // Destroy

end.
